[packages/nginx] init: add configtest
glen
glen at pld-linux.org
Sun May 3 22:04:28 CEST 2015
commit ab8302f087c7063d446b9dc074ff12c461c450ff
Author: Elan Ruusamäe <glen at delfi.ee>
Date: Sun May 3 23:02:12 2015 +0300
init: add configtest
nginx.init | 45 ++++++++++++++++++++++++++++++++++++++++++++-
1 file changed, 44 insertions(+), 1 deletion(-)
---
diff --git a/nginx.init b/nginx.init
index 2ef3143..38c75cd 100755
--- a/nginx.init
+++ b/nginx.init
@@ -38,9 +38,46 @@ else
exit 0
fi
+# configtest itself
+# must return non-zero if check failed
+# output is discarded if checkconfig is ran without details
+configtest() {
+ $nginx -t -c $NGINX_CONF_FILE
+}
+
+# wrapper for configtest
+checkconfig() {
+ local details=${1:-0}
+
+ if [ $details = 1 ]; then
+ # run config test and display report (status action)
+ show "Checking %s configuration" "$svname"; busy
+ local out
+ out=$(configtest 2>&1)
+ RETVAL=$?
+ if [ $RETVAL = 0 ]; then
+ ok
+ else
+ fail
+ fi
+ [ "$out" ] && echo >&2 "$out"
+ else
+ # run config test and abort with nice message if failed
+ # (for actions checking status before action).
+ configtest >/dev/null 2>&1
+ RETVAL=$?
+ if [ $RETVAL != 0 ]; then
+ show "Checking %s configuration" "$svname"; fail
+ nls 'Configuration test failed. See details with %s "checkconfig"' $0
+ exit $RETVAL
+ fi
+ fi
+}
+
start() {
# Check if the service is already running?
if [ ! -f $lockfile ]; then
+ checkconfig
msg_starting "$svname"
daemon $nginx -c $NGINX_CONF_FILE
RETVAL=$?
@@ -66,6 +103,7 @@ stop() {
reload() {
if [ -f $lockfile ]; then
+ checkconfig
msg_reloading "$svname"
killproc $prog -HUP
RETVAL=$?
@@ -82,6 +120,7 @@ condrestart() {
return
fi
+ checkconfig
stop
start
}
@@ -96,6 +135,7 @@ case "$1" in
stop
;;
restart)
+ checkconfig
stop
start
;;
@@ -105,12 +145,15 @@ case "$1" in
reload|force-reload|graceful)
reload
;;
+ checkconfig|configtest)
+ checkconfig 1
+ ;;
status)
status $prog
RETVAL=$?
;;
*)
- msg_usage "$0 {start|stop|restart|reload|force-reload|graceful|status}"
+ msg_usage "$0 {start|stop|restart|try-restart|reload|force-reload|graceful|checkconfig|status}"
exit 3
;;
esac
================================================================
---- gitweb:
http://git.pld-linux.org/gitweb.cgi/packages/nginx.git/commitdiff/ab8302f087c7063d446b9dc074ff12c461c450ff
More information about the pld-cvs-commit
mailing list